<?php /*
phpWebTrace 1.0 - install.php
Copyright (C) 2005 Instinctive Interactive Ltd
www.instinctiv-e.com

$LastChangedDate: 2005-10-21 05:09:56 +0100 (Fri, 21 Oct 2005) $
$Id: install.php 4 2005-10-21 04:09:56Z paulbrennan $

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
// ----------------------------------------------------------------------
$success = true; // set success out here so the error log is not shown on initial page entry
$errorlog = '';

// check for existence of config.php file
if (file_exists('config.php')) {  $success = false; $errorlog.="&middot; Configuration file already exists -<br>&nbsp; delete before continuing!<br>"; }

// set form defaults
if (!isset($dbprefix) ) { $dbprefix="webtrace_"; } // set default table name prefix
if (!isset($dbhost) ) { $dbhost="localhost"; } // set default hostname
if (!isset($dbname) ) { $dbname="phpwebtrace"; } // set default database name
If (!isset($downloads_dir) ) { $downloads_dir="downloads/"; } // set default location of any downloadable files

// check for existence of GeoIP.dat in known install locations
if (file_exists('/usr/local/share/GeoIP/GeoIP.dat')) { $geoip_path='/usr/local/share/GeoIP/GeoIP.dat'; }
elseif (file_exists('/usr/share/GeoIP/GeoIP.dat')) { $geoip_path='/usr/share/GeoIP/GeoIP.dat'; }
else { $geoip_path=""; }

// has form been POSTed?
if(isset($_POST['submit_install'])) {
	
	// collect POST vars
	if (!empty($_POST['dbname'])) { $dbname = $_POST['dbname']; }
	if (!empty($_POST['dbhost'])) { $dbhost = $_POST['dbhost']; }
	if (!empty($_POST['dbuser'])) { $dbuser = $_POST['dbuser']; } else { $dbuser = ''; }
	if (!empty($_POST['dbpass'])) { $dbpass = $_POST['dbpass']; } else { $dbpass = ''; }
	if (!empty($_POST['dbprefix'])) { $dbprefix = $_POST['dbprefix']; } else { $dbprefix = ''; }
	if (!empty($_POST['username'])) { $username = $_POST['username']; } else { $username = ''; }
	if (!empty($_POST['password'])) { $password = $_POST['password']; } else { $password = ''; }
	if (!empty($_POST['confirm'])) { $confirm = $_POST['confirm']; } else { $confirm = ''; }
	if (!empty($_POST['geoip_path'])) { $geoip_path = $_POST['geoip_path']; } else { $geoip_path = ''; }
	if (!empty($_POST['downloads_dir'])) { $downloads_dir = $_POST['downloads_dir']; } else { $downloads_dir = ''; }

	// ensure any entered geoip.dat path exists
	if ( $geoip_path != "" && !file_exists("$geoip_path")) { 
		$success = false; $errorlog.="&middot; The GeoIP.dat file could not be found at $geoip_path<br>";
	}
	
	// ensure any entered downloads path exists
	if ( $downloads_dir != "" ) {
		// is the directory relative or a full path
		 if ( ("/"===substr($downloads_dir,0,1) && !file_exists("$downloads_dir")) || !file_exists("../$downloads_dir") ) {
				if ( "/"===substr($downloads_dir,0,1) && !mkdir("$downloads_dir") ) {
					$success = false; $errorlog.="&middot; The downloads directory '$downloads_dir' does not exist and can't be created.<br>";
				}
				elseif (!mkdir("../$downloads_dir") ) {
					$success = false; $errorlog.="&middot; The downloads directory '$downloads_dir' does not exist and can't be created.<br>";
				}
		}
		// check for trailing slash or add one
		if ( "/"!==substr($downloads_dir,strlen($downloads_dir)-1,1)) {
		 		$downloads_dir .= "/";
		}
	}

	// check passwords entered match
	if($_POST['password'] != $_POST['confirm']) {
		$success = false; $errorlog.="&middot; Login passwords do not match<br>";
	}
	
	$dblog = $dbprefix.'stats';
	$dblog_trace = $dbprefix.'trace';
	$dbcfg = $dbprefix.'config';
	$dblogarchive = $dbprefix.'stats_archive';
	$dblog_dloads = $dbprefix.'dloads';
	
	// connect to database
	$link = @mysql_connect($dbhost, $dbuser, $dbpass);
	if(!$link) { $success = false; $errorlog.="&middot; Connection to database server failed!<br>"; }
	
	// create database if it doesn't exist
	if($success && !@mysql_query("CREATE DATABASE IF NOT EXISTS $dbname", $link)) {
		$success = false; $errorlog.="&middot; Unable to create database<br>";
	}
	
	// create initial visit log table
	if ( $success ) {
		@mysql_db_query($dbname, "DROP TABLE IF EXISTS $dblog", $link);
		$query = "CREATE TABLE $dblog (id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		timestamp NUMERIC(10),
		datestamp NUMERIC(8),
		hourstamp NUMERIC(2),
		ip CHAR(15),
		country_code CHAR(2),
		host VARCHAR(75),
		referer VARCHAR(250),
		referer_host VARCHAR(75),
		client VARCHAR(250),
		browser VARCHAR(25),
		os VARCHAR(25),
		engine VARCHAR(25),
		terms VARCHAR(150),
		entry VARCHAR(150),
		mail VARCHAR(255)
		)";
		if(!@mysql_db_query($dbname, $query, $link)) {
			$success = false; $errorlog.="&middot; Unable to create $dblog table<br>";
		}
	}
	
	// create trace log table
	if ( $success ) {
		@mysql_db_query($dbname, "DROP TABLE IF EXISTS $dblog_trace", $link);
		$query = "CREATE TABLE $dblog_trace (id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		stats_id INT(11) NOT NULL,
		timestamp NUMERIC(10),
		page VARCHAR(150),
		query VARCHAR(150)
		)";
		if(!@mysql_db_query($dbname, $query, $link)) {
			$success = false; $errorlog.="&middot; Unable to create $dblog_trace table<br>";
		}
	}
	
	// create archive log table
	if ( $success ) {
		@mysql_db_query($dbname, "DROP TABLE IF EXISTS $dblogarchive", $link);
		$query = "CREATE TABLE $dblogarchive (id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		timestamp NUMERIC(10),
		datestamp NUMERIC(8),
		hourstamp NUMERIC(2),
		ip CHAR(15),
		host VARCHAR(75),
		referer VARCHAR(250),
		referer_host VARCHAR(75),
		client VARCHAR(250),
		browser VARCHAR(25),
		os VARCHAR(25),
		engine VARCHAR(25),
		terms VARCHAR(150),
		entry VARCHAR(150),
		mail VARCHAR(255)
		)";
		if(!@mysql_db_query($dbname, $query, $link)) {
			$success = false; $errorlog.="&middot; Unable to create $dblogarchive table<br>";
		}
	}
	
	// create configuration table
	if ( $success ) {
		@mysql_db_query($dbname, "DROP TABLE IF EXISTS $dbcfg", $link);
		$query = "CREATE TABLE $dbcfg (id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		timestamp NUMERIC(10),
		domain VARCHAR(70),
		site_title VARCHAR(70),
		username VARCHAR(20),
		password VARCHAR(20),
		ip CHAR(15),
		logged_in bool
		)";
		if(!@mysql_db_query($dbname, $query, $link)) {
			$success = false; $errorlog.="&middot; Unable to create $dbcfg table<br>";
		}
	}
	
	// create downloads log table
	if ( $success ) {
		@mysql_db_query($dbname, "DROP TABLE IF EXISTS $dblog_dloads", $link);
		$query = "CREATE TABLE $dblog_dloads (id INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		timestamp NUMERIC(10),
		datestamp NUMERIC(8),
		hourstamp NUMERIC(2),
		ip CHAR(15),
		host VARCHAR(75),
		referer VARCHAR(250),
		referer_host VARCHAR(75),
		client VARCHAR(250),
		browser VARCHAR(25),
		os CHAR(25),
		engine VARCHAR(25),
		terms VARCHAR(150),
		file VARCHAR(150),
		size NUMERIC(11),
		mail VARCHAR(255)
		)";
		if(!@mysql_db_query($dbname, $query, $link)) {
			$success = false; $errorlog.="&middot; Unable to create $dblog_dloads table<br>";
		}
	}

	// create config file
	if ( $success ) {
		$fp = @fopen('./config.php', "w+");
		$string = 
		"<?php\n".
		'// DO NOT EDIT THIS FILE'."\n".
		'// Automatically generated by phpWebTrace install.php'."\n".
		'$dbhost = ' . "'$dbhost';\n".
		'$dbuser = ' . "'$dbuser';\n".
		'$dbpass = ' . "'$dbpass';\n".
		'$dbname = ' . "'$dbname';\n".
		'$dblog = ' . "'$dblog';\n".
		'$dblog_trace = ' . "'$dblog_trace';\n".
		'$dblog_dloads = ' . "'$dblog_dloads';\n".
		'$dblogarchive = ' . "'$dblogarchive';\n".
		'$dbcfg = ' . "'$dbcfg';\n".
		'$downloads_dir = ' . "'$downloads_dir';\n".
		'$geoip_path = ' . "'$geoip_path';\n".
		"?>";
		if(!fwrite($fp, $string)) { $success = false; $errorlog.="&middot; Unable to create configuration file<br>"; }
		@fclose($fp);
	}
	
	// chmod of confdata file
	if ( $success ) {
		chmod('config.php', 0600);
	}
	
	// store username and password in configuration table
	$time = time();
	if ( $success ) {
		if(!@mysql_db_query($dbname, "INSERT INTO $dbcfg VALUES ('0', '$time', '$domain', '$site_title', '$username', '$password', NULL, NULL)", $link)) {
			$success = false; $errorlog.="&middot; Unable to store configuration information<br>";
		}
		@mysql_close($link);
	}
	
	// if installation was successful, display message
	if($success) {
		echo "
		<html>
		<head>
		<title>phpWebTrace v1.0 Installation</title>
		<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>
		<link href='css/default.css' rel='stylesheet' type='text/css'>
		</head>
		
		<body>
		<table width='100%' height='100%' border=0><tr><td align='center' valign='middle'>
		
		<table width='400' border='1' cellpadding='2' cellspacing='0' bordercolor='#CCCCCC'>
		  <tr><td>
		  <table class='text' width=400 border=0 cellpadding=3 cellspacing=0>
			<tr>
				<td align='center'>
					<img src='graphics/logo.jpg'><br>
					<br><br>
					<center><font class='success'>Congratulations</font> <b>you have successfully installed phpWebTrace</b>.</center><br>
					<br>
					To begin tracing visitors on your site place the code below at the top of each page you want to track:<br>
					<br>
					<center>
					<div style='width:350' class='code_box'>
					<font class='code_red'>&lt;?</font>
					<font class='code_blue'>session_start()</font><font class='code_black'>;</font>
					<font class='code_black'>@</font><font class='code_blue'>include</font> 
					<font class='code_red'>'phpwebtrace.php'</font><font class='code_black'>;</font> 
					<font class='code_red'>?&gt;</font>
					</div>
					</center>
					<br>
					The files you insert the tracking code above into must be PHP files.<br>
					<br>
					Make sure that the <b>phpwebtrace.php</b> file is in the root directory of your site ( where your site's index
					file is. )<br>
					<br>
					Click <a href='index.php'>here</a> to go to your phpWebTrace report pages.
					<br>
					<br>
				<center><font class='fine'>[ As a precaution, this file (install.php) has been deleted. ]</font></center></td>
			</tr>
		  </table>
		  </td></tr>
		</table>

		</td></tr></table>
		</body>
		</html>
		";
		
		// remove this file
		unlink('install.php');
		
		exit();
	}
}
if (!$success) { $errorlog = "ERRORS:<br>".$errorlog; }
?>
<html>
<head>
<title>phpWebTrace v1.0 Installation</title>
<meta http-equiv='Content-Type' content='text/html; charset=iso-8859-1'>
<link href='css/default.css' rel='stylesheet' type='text/css'>
</head>

<body>
<table width='100%' height='100%' border=0><tr><td align='center' valign='middle'>

<form action='<?php echo $PHP_SELF; ?>' method=post onSubmit=''>
<table width='500'  border='1' cellspacing='0' cellpadding='2'>
  <tr><td>
  <table width='500' border='0' cellpadding='3' cellspacing='0' class='text'>
	<tr><td colspan=2 align='center'><img src='graphics/logo.jpg'><br><b>phpWebTrace v1.0 Installation</b><br><br>
	<table class='error' width=250 border=0 cellpadding=0 cellspacing=0><tr><td><?=$errorlog?></td></tr></table>
	</td></tr>
	
	<tr><td width='45%' align='right'>Database Host</td><td width='275'><input class='form' type=text name='dbhost' value='<?php echo $dbhost; ?>' alt='required'></td></tr>
	<tr><td align='right'>Database Username</td><td><input class='form' type=text name='dbuser' value='<?php echo $dbuser; ?>' alt='required'></td></tr>
	<tr><td align='right'>Database Password</td><td><input class='form' type=password name='dbpass' value='<?php echo $dbpass; ?>'></td></tr>
	<tr><td align='right'>Database Name</td><td><input class='form' type=text name='dbname' value='<?php echo $dbname; ?>' alt='required'></td></tr>
	<tr><td align='right'>Table Name Prefix</td><td><input class='form' type=text name='dbprefix' value='<?php echo $dbprefix; ?>' alt='required'></td></tr>
	<tr><td align='right'>&nbsp;</td><td>&nbsp;</td></tr>
	<tr><td colspan='2' align='center'>To password protect the phpWebTrace results pages - enter a username and password below.</td></tr>
	<tr><td align='right'>Login Username</td><td><input class='form' type=text name='username' value='<?php echo $username; ?>'></td></tr>
	<tr><td align='right'>Login Password</td><td><input class='form' type=password name='password' value='<?php echo $password; ?>'></td></tr>
	<tr><td align='right'>Confirm Password </td><td><input class='form' type=password name='confirm' value='<?php echo $confirm; ?>'></td></tr>
	<tr><td align='right'>&nbsp;</td><td>&nbsp;</td></tr>
	<tr><td colspan='2' align='center'><strong>IP Address to Country</strong><br>If you have GeoIP installed you should enter the full path to the GeoIP.dat database below. If the field is already populated then the installer automatically located it for you. GeoIP.dat can be downloaded <a href="http://www.maxmind.com/app/geoip_country">here</a>. </td></tr>
	<tr align='center'><td colspan='2'><input name='geoip_path' type=text class='form' value='<?php echo $geoip_path; ?>' size='50'></td></tr>
	<tr align='center'><td colspan='2'>&nbsp;</td></tr>
	<tr align='center'><td colspan='2'><strong>phpFileTrace</strong><br>
	Enter the location of your downloads directory, this should preferably be a non web accessable directory. The path should have a trailing slash; e.g. 'downloads/' if the directory doesn't exist it will be created. If you don't wish to use a downloads directory simply leave this field blank.</td>
	</tr>
	<tr align='center'><td colspan='2'><input name='downloads_dir' type=text class='form' value='<?php echo $downloads_dir; ?>' size='50'></td></tr>
	<tr><td class='fine' colspan='2' align='center'>
		<br><input class='text' type=submit value='Install'><input type='hidden' name='submit_install' value='1'><br><br>
		Having problems installing..? Visit the <a href='http://dev.instinctiv-e.com/forums/viewforum.php?f=9'>Support Forums</a><br>
		phpWebTrace v1.0 &copy;2005 <a href='http://www.instinctiv-e.com'>Instinctive Interactive Ltd</a>. All rights reserved.<br></td></tr>
</table>
  </td></tr>
</table>

</form>

</td></tr></table>
</body>
</html>