## Mysql Script to alter phpWebTrace db schema to version 1.0.1
## Alter the table names to suite your installation.
##
## To Use:
## $ mysql -p < upgrade.1.0.1.sql

USE phpwebtrace;

## Add a new column to the stats table.
ALTER TABLE webtrace_stats ADD country_code char(2) AFTER ip;
UPDATE webtrace_stats SET country_code='';

## Change CHAR data types to VARCHAR
ALTER TABLE webtrace_stats MODIFY host VARCHAR(75), 
    MODIFY referer VARCHAR(250), 
    MODIFY referer_host VARCHAR(75), 
    MODIFY client VARCHAR(250), 
    MODIFY browser VARCHAR(25), 
    MODIFY os VARCHAR(25), 
    MODIFY engine VARCHAR(25), 
    MODIFY terms VARCHAR(150), 
    MODIFY entry VARCHAR(150), 
    MODIFY mail VARCHAR(255);

ALTER TABLE webtrace_trace MODIFY page VARCHAR(150), 
    MODIFY query VARCHAR(150);

ALTER TABLE webtrace_dloads MODIFY host VARCHAR(75), 
    MODIFY referer VARCHAR(250), 
    MODIFY referer_host VARCHAR(75), 
    MODIFY client VARCHAR(250), 
    MODIFY browser VARCHAR(25), 
    MODIFY os VARCHAR(25), 
    MODIFY engine VARCHAR(25), 
    MODIFY terms VARCHAR(150), 
    MODIFY file VARCHAR(150), 
    MODIFY mail VARCHAR(255);

